ActiveRecord::Statementinvalid and postgres undefinedtable when searching puppetclasses in
Foreman 1.3.0
Description
Hi guys, | searched through the issues, but did not see this one already...

In Foreman 1.3.0, when searching puppetclasses in the web gui, e.g.
http://foreman/puppetclasses?utf8=%E2%9C%93&search=webcerts, | get the following error:

ActiveRecord: :StatementInvalid

PG::UndefinedTable: ERROR: missing FROM-clause entry for table "environments" LINE 1: ...RE (("pup
petclasses"."name" ILIKE 'Swebcerts$%$' OR "environme... SELECT "puppetclasses"."id" FROM "puppe
tclasses" WHERE (("puppetclasses"."name" ILIKE 'Swebcerts$' OR "environments"."name" ILIKE 'S%$webce
rts%' OR "hostgroups"."name" ILIKE 'S$webcerts%' OR "lookup_keys"."key" ILIKE 'S%webcerts$')) ORDER
BY puppetclasses.name LIMIT 20 OFFSET O

app/controllers/puppetclasses_controller.rb:17:in "~ index'
app/models/concerns/foreman/thread_session.rb:33:in “clear_thread'
lib/middleware/catch_json_parse_errors.rb:9:in ‘call'

| just upgraded to Foreman 1.3.0 from 1.2.2. Here is my puppetmaster/foreman host setup:

CentOS 6.4

Puppet 3.3.1

PuppetDB 1.5.2

Postgres 9.1 databases for Foreman and puppetDB

Puppet master and Foreman are served via Apache 2.4.6 and passenger 4.0.5
Ruby 1.8.7

| upgraded the node.rb and foreman.rb scripts per http://theforeman.org/manuals/1.3/index.html#Upgradenotes. There's definitely an
"environments" table that exists in the foreman postgres DB.

Let me know if you need more info.

Associated revisions

Revision 9e08f306 - 11/14/2013 04:44 PM - Dmitri Dolguikh

fixes #3603 - replaced a relation with a collection in 'where' conditions
Revision 3387b1cd - 11/15/2013 10:00 AM - Dmitri Dolguikh

fixes #3603 - replaced a relation with a collection in 'where' conditions
(cherry picked from commit 9e08f306472c16c8c019fe7c038b5cb44bd5a28e)

Conflicts:
app/controllers/puppetclasses_controller.rb

History

#1 - 11/07/2013 06:19 PM - Dominic Cleal
http://foreman/puppetclasses?utf8=%E2%9C%93&search=webcerts
http://theforeman.org/manuals/1.3/index.html#Upgradenotes

- translation missing: en.field_release set to 3

I'm surprised this got through RCs! Thanks for the report.

#2 - 11/08/2013 12:23 PM - Anonymous

Similarly, when ordering puppet classes by environment (/puppetclasses?order=environment+ASC&search=), | see:

SQLite3::SQLException: no such column: environments.name: SELECT "puppetclasses"."id" FROM "puppetclasses" ORDER BY

"environments"."name" ASC LIMIT 20 OFFSET 0
Completed 500 Internal Server Error in 11.9ms

ActiveRecord::Statementinvalid (SQLite3::SQLException: no such column: environments.name: SELECT "puppetclasses"."id" FROM
"puppetclasses” ORDER BY "environments"."name" ASC LIMIT 20 OFFSET 0):

#3 - 11/11/2013 12:24 PM - Anonymous

- Status changed from New to Assigned

#4 - 11/12/2013 12:06 PM - Anonymous
- Target version set to 1.10.0

- Assignee set to Anonymous

#5 - 11/13/2013 10:26 PM - Anonymous
- Status changed from Assigned to Ready For Testing

PR: https://github.com/theforeman/foreman/pull/1021

#6 - 11/14/2013 05:31 PM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 9e08{306472c16c8c019fe7c038b5cb44bd5a28e.
